pro filter_image, image, filtered_image

Xdim = (size(image))(1)
Ydim = (size(image))(2)
;
fft_ima = sqrt(Xdim*Ydim)*fft(image,-1)        ; Direct Fourier Transform

kxarray  = dblarr(Xdim,Ydim)
kyarray  = dblarr(Xdim,Ydim)
;
linx = findgen(1+Xdim/2)*(1./Xdim)
liny = findgen(1+Ydim/2)*(1./Ydim)
;
echant = 3
;pixel = 5.85				    ; Pixel size of P-ArTeMiS array (Nov. 2007) in arcsec	
;xinc0 = 5.85/echant			    ; Pixel size in arcsec for rebinned images
pixel = 6.2				    ; Pixel size of P-ArTeMiS array (Nov. 2007) in arcsec	
xinc0 = 6.2/echant			    ; Pixel size in arcsec for rebinned images
rinc0 = abs(xinc0)*!pi/(180.*3600)          ; Pixel size in radians
;
; Unit in spatial frequency domain: klambda
sunit = 1.e3
linx = linx/(rinc0*sunit)	    ; Spatial frequencies in klambdas
liny = liny/(rinc0*sunit)
;
klim = 1./(2*echant*rinc0)/sunit     ; Highest spatial frequency that can be sampled given the array pixel size of 5.85"/6.2"
;
for j = 0,Ydim-1 do kxarray(0:Xdim/2,j) = linx
for j = 0,Ydim-1 do kxarray(1+Xdim/2:Xdim-1,j) = -reverse(linx(1:Xdim/2-1))
;
for i = 0,Xdim-1 do kyarray(i,0:Ydim/2) = liny
for i = 0,Xdim-1 do kyarray(i,1+Ydim/2:Ydim-1) = -reverse(liny(1:Ydim/2-1))
;
krarray = sqrt(kxarray^2+kyarray^2)
kmax = max(krarray)
kmin = min(krarray(where(krarray gt 0.)))
k0 = kmin
;
;radprof_pows =circav(centre(abs(fft_ima)^2))
;wset, 1
;plot_oo, krarray(0:xdim/2), radprof_pows, $
;xtitle="Spatial Frequency (klambda)", ytitle="Amplitude", $
;title="Power Spectrum", $
;xrange=[kmin/2.,kmax*2.], /XSTYLE, yrange=[1.e-10,1.e10],/YSTYLE, $
;psym = 1
;
fft_ima_filtered = fft_ima
ind = where(krarray gt klim)
fft_ima_filtered(ind) = complex(0,0)

comp_filtered_ima = fft(fft_ima_filtered,+1)/sqrt(Xdim*Ydim)	; Inverse Fourier Transform
filtered_image = double(comp_filtered_ima)
imaginary_ima = imaginary(comp_filtered_ima)

ind = where(image eq 0., count)
if count gt 0 then filtered_image(ind) = 0.

return
end


