function grid_kernel_xy, dx, dy, fine_pix
;
;	INPUTS: Angular offsets in x and y from point source center (radius)	;   fine_pix = fine pixel = pfov_ref/echant
;	OUTPUT: Signal (normalized to 1 at source center)
;

;fwhm = 3.87/10.		; arcsec
fwhm = fine_pix*3./10.		; arcsec

;print, "grid fwhm (arcsec)", fwhm 

radius =  sqrt(dx^2+dy^2)

arg_exp = alog(2.)*(2.*radius/fwhm)^2

;

psf = dx*0. + dy*0.

ind = where(abs(dx) le fine_pix and abs(dy) le fine_pix and arg_exp le 86. and radius le fwhm, count)
 
if count gt 0 then begin
; psf(ind) = 1.
  psf(ind) = exp(-arg_exp(ind))
endif

;
return, psf
end
