pro noise_scan, scan_number, cube_7339_in, goodpix_ima_7339

; Usage: 
;   	noise_scan, 30397, data_sky, goodpix_ima_7339
;
; !path = '/Users/artemis/Desktop/apex_idl/apexpro:'+!path
; @obs1_config
; restore, Calib_partemis+'goodpix_ima_venus_23824_19may09.xdr', /verb   ;  --> restoring goodpix_ima
; restore, Calib_partemis+'flat_venus_23824_19may09.xdr', /verb   ;  --> restoring flat_field
;
; init_obs, scan_number= 24537, type = 'map', init_obs_24537_str
; goodpix_ima = init_obs_24537_str.goodpix_ima
; flat_field = init_obs_24537_str.flat_field 
;
; ima_amb_cold_24537 = fltarr(16,16)
; noise_fft_cal, 24537, goodpix_ima, cal_noise_str, amb_cold = ima_amb_cold_24537
;
; conv = init_obs_24537_str.conv		;  2.0e-4			; Mars/Uranus/Neptune May 2009
;
; conv = 2.66890e-4				; conv_mars_24822(7,7)
; restore, '/Users/pandre/kosma/artemis/Calib_partemis/flat_mars_24822_22may09.xdr', /verb		; --> restoring flat_field
; flat_field(0,15) = 1.
;
; for i = 0, 2 do print, "Power = ", cal_noise_str(i).mean_level_av,"  ", cal_noise_str(i).scanname, "   El = ", cal_noise_str(i).elevatio
; for i = 0, 2 do print, "Median NEFD = ", median((exp(0.8/sin(50*!pi/180.))/sqrt(40.))*cal_noise_str(i).rms_noise_corr/flat_field/conv)
; for i = 0, 2 do print, "Min NEFD = ", min((exp(0.8/sin(50*!pi/180.))/sqrt(40.))*cal_noise_str(i).rms_noise_corr/flat_field/conv)
; atv, (exp(0.8/sin(50*!pi/180.))/sqrt(40.))*cal_noise_str(1).rms_noise_corr/flat_field/conv
;
; noise_fft_skydip, 24538, sky_noise_str
; for i = 0, 5 do print, "Power = ", sky_noise_str(i).mean_level_av,"  ", sky_noise_str(i).scanname, "   El = ", sky_noise_str(i).elevatio
; for i = 0, 5 do print, "Median NEFD = ", median((exp(0.8/sin(50*!pi/180.))/sqrt(40.))*sky_noise_str(i).rms_noise_corr/flat_field/conv)
; for i = 0, 5 do print, "Min NEFD = ", min((exp(0.8/sin(50*!pi/180.))/sqrt(40.))*sky_noise_str(i).rms_noise_corr/flat_field/conv)
;
; Inputs :  cal_number (log)  goodpix_ima(16,16)
; Ouput:   noise_str

;if n_params() eq 0 then begin
;	print, 'Calling sequence :'
;	print, '	NOISE_FFT_CAL, cal_number, goodpix_ima, noise_str, amb_cold = amb_cold
;	return
;endif	

init_obs, scan_number=scan_number, type='map', init_obs_str

Conv = init_obs_str.conv

print, "Conv= ", Conv			    	    	    	    	    	    ; V/Jy

flat_field = init_obs_str.flat_field
ind_zero = where(init_obs_str.flat_field eq 0, cnt_zero)
if cnt_zero gt 0 then flat_field(ind_zero) = 1.

cube_7339 =  cube_7339_in   	    	    	    	    	    	    	    ; uncalibrated

cube_7339 = double(cube_7339)/Conv		    	    	    	    	    ; Calibration (V --> Jy conversion only   NO OPACITY CORRECTION)

flat_cube = cube_7339*0.
for kk=0L, (size(cube_7339))(3)-1 do flat_cube(*,*,kk) = flat_field
cube_7339 = cube_7339/flat_cube	      	    	    	    	    	    	    ; Flat field correction


;bidon = fltarr(16,16)
;bidon(9:13,8:13) = 1.
;mask = bidon

bidon = fltarr(73,39)
bidon(46:50,24:29) = 1.
mask = bidon

taille = size(cube_7339)
mean_level = dblarr(taille(1),taille(2))
rms_noise = dblarr(taille(1),taille(2))

n_images = taille(3)

test_decorrel, cube_7339, mask, cube_7339_corr, correl_matrice, a_matrice

index = where(goodpix_ima_7339 gt 0)

cube = cube_7339 
;
for j = 0, taille(2)-1 do begin
   for i = 0, taille(1)-1 do begin
;;     if goodpix_ima(i,j) gt 0. then begin
	rms_noise(i,j)   = stdev(cube(i,j,*))
        signal = cube(i,j,*)
	mean_level(i,j)  = mean(signal)	
      if keyword_set(sub_mean) then begin
	signal = signal-mean_level(i,j)
      endif	
;	ft_signal = fft(signal)
;	pow_spec = float(ft_signal*conj(ft_signal))
;	cube_pow_spec(i,j,*) = pow_spec
;;     endif
   endfor
endfor

mean_level_med = median(mean_level(index))
rms_noise_med = median(rms_noise(index))

print, "Median level over valid pixels after calibration (Jy) : ", mean_level_med
print, "Median rms noise over valid pixels after calibration (Jy) : ", rms_noise_med

;stop

;;;;;
;;;;;


cube = cube_7339_corr
;
for j = 0, taille(2)-1 do begin
   for i = 0, taille(1)-1 do begin
;;     if goodpix_ima(i,j) gt 0. then begin
	rms_noise(i,j)   = stdev(cube(i,j,*))
        signal = cube(i,j,*)
	mean_level(i,j)  = mean(signal)	
      if keyword_set(sub_mean) then begin
	signal = signal-mean_level(i,j)
      endif	
;	ft_signal = fft(signal)
;	pow_spec = float(ft_signal*conj(ft_signal))
;	cube_pow_spec(i,j,*) = pow_spec
;;     endif
   endfor
endfor

mean_level_corr_med = median(mean_level(index))
rms_noise_corr_med = median(rms_noise(index))

print, "Median level over valid pixels after calibration and decorrelation (Jy) : ", mean_level_corr_med
print, "Median rms noise over valid pixels after calibration and decorrelation (Jy) : ", rms_noise_corr_med

;stop

return
end


