;+
; NAME:
;	SIGMA_CLIP
;
; PURPOSE:
;	Flag data that are within average +- threshold*rms.
;
;
; CATEGORY:
;	
;
; CALLING SEQUENCE:
;	
;	Indices = SIGMA_CLIP(Data, Threshold)
;
; INPUTS:
;	Data:		Input data. 
;	Threshold:	Threshold.
;
;
; EXAMPLE:
;
;		Indices = SIGMA_CLIP(Data, Threshold)
;
; MODIFICATION HISTORY:
;
;-

function sigma_clip, data, threshold


if n_params() eq 0 then begin
	print, 'Calling sequence :'
	print, '	indices = sigma_clipping( data, threshold)'
	return, -1
endif

donnees = data

n_point_prev = n_elements(data)
n_point = 0

indices = indgen(n_point_prev)

while n_point ne n_point_prev and n_point_prev gt 3 do begin
	n_point_prev = n_point
	moyenne = mean(donnees)
	rms = sigma(donnees)
	vbas = moyenne - threshold*rms
	vhaut = moyenne + threshold*rms
	indices = where(donnees gt vbas and donnees lt vhaut, n_point)
	donnees = donnees(indices)
endwhile

;indices = where(data gt vbas and data lt vhaut)

return, indices
end
